<?php

function mass_sms_modal_function()
{
    ?>
    <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <?php echo send_sms_heading(); ?>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <?php echo send_mass_sms_modal_content(); ?>
                </div>
                <!-- <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>

                </div> -->
            </div>
        </div>
    </div>
    <?php
}

function send_mass_sms_modal_content()
{

    $sms_options = get_presets();


    ?>
    <div class="modulus-user-sms">

        <div style="display: flex;flex-direction:column;">
            <label for="template_options" style="font-weight: bold; margin-right: 46px;">Πρότυπο Μηνύματος</label>
            <select id="template_options" name="template_options">
                <option value="">
                    <?php _e('-Επιλέξτε-', 'woo-sms-alerts'); ?>
                </option>
                <?php
                foreach ($sms_options as $value) {
                    echo '<option value="' . esc_attr($value['id']) . '">' . esc_html($value['title']) . '</option>';
                }
                ?>
            </select>
        </div>
        <div class="form-row" style="margin-bottom:1em;margin-top:1em;">
            <?php echo sms_instructions_text();
            echo instructions_sms_list('')
                ?>


        </div>
        <div class="form-table">
            <div class="form-row">
                <div>
                    <label for="message_user_field" style="font-weight: bold;">Μήνυμα</label>
                </div>
                <div>
                    <textarea name="message_user_field" id="message_user_field" class="regular-text"
                        style="width: 375px !important; height: 200px !important;"><?php echo esc_textarea($custom_value); ?></textarea>
                </div>
            </div>
        </div>

        <div style="margin-bottom:1em!important;display:flex;justfy-content:flex-end;width:100%!important;">

            <span id="character_count"></span>
            &nbsp;
            <span id="character_warning"></span>

        </div>
        <div class="footer_modal_">
            <button class="button button-primary sms-button-user" id="send-sms-button-user">Αποστολή SMS</button><br />
            <?php echo close_modal_btn(); ?>
        </div>
        <span class="description"></span>

    </div>

    <script>

        jQuery(document).ready(function ($) {
            $('#template_options').on('change', function () {
                var selectedTemplateId = $(this).val();


                if (selectedTemplateId !== '') {

                    $.ajax({
                        url: '<?php echo admin_url('admin-ajax.php'); ?>',
                        type: 'POST',
                        data: {
                            action: 'get_template_details',
                            templateId: selectedTemplateId
                        },
                        success: function (response) {

                            var trimmedResponse = response.trim();
                            $('#message_user_field').val(trimmedResponse);
                            check_char_count("#exampleModal #message_user_field", "#exampleModal");
                        }
                    });
                } else {

                    $('#message_user_field').val('');
                }
            });
        });
    </script>

    <script>
        jQuery(document).ready(function ($) {
            $('#message_user_phone').val($('#billing_phone').val());

            $('#send-sms-button-user').on('click', function (e) {
                e.preventDefault();
                var smsMessageuser = $('#message_user_field').val();
                // var phoneNumberuser = [];

                // $('input[name="select_user[]"]:checked').each(function () {

                //     phoneNumberuser.push($(this).val())
                // });
                var userIDs = [];
                $('input[name="select_user[]"]:checked').each(function () {

                    userIDs.push($(this).val())
                });
                if (smsMessageuser.trim() === '') {

                    alert('Please enter a message before sending.');
                } else {
                    $.ajax({
                        url: '<?php echo admin_url('admin-ajax.php'); ?>',
                        method: 'POST',
                        data: {
                            action: 'send_sms_mass_callback',
                            user_ids: userIDs,
                            // phoneNumber: phoneNumberuser,
                            message: smsMessageuser
                        },
                        success: function (response) {

                            console.log(response);
                            alert('Message sent!');

                            window.location.reload();

                            $('#message_user_field').val('');
                            $('#billing_phone').val('');
                        },
                        error: function (error) {

                            console.error(error);
                        }
                    });
                }
            });
        });
    </script>

    <?php
}

function mass_sms_modal_function_singular()
{
    ?>
    <div class="modal fade" id="singularModal" tabindex="-1" aria-labelledby="exampleModalLabel_" aria-hidden="true">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <?php echo send_sms_heading(); ?>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <?php echo send_mass_sms_modal_content_singular(); ?>
                </div>
               
            </div>
        </div>
    </div>
    <?php
}


function send_mass_sms_modal_content_singular()
{

    $sms_options = get_presets();

    ?>
    <div class="modulus-user-sms">

        <div style="display: flex;flex-direction:column;">
            <label for="template_options" style="font-weight: bold; margin-right: 46px;">Πρότυπο Μηνύματος</label>
            <select id="template_options_" name="template_options">
                <option value="">
                    <?php _e('-Επιλέξτε-', 'woo-sms-alerts'); ?>
                </option>
                <?php
                foreach ($sms_options as $value) {
                    echo '<option value="' . esc_attr($value['id']) . '">' . esc_html($value['title']) . '</option>';
                }
                ?>
            </select>
        </div>

        <div class="form-container">

            <div class="form-row">
                <div>
                    <label for="message_user_phone" style="font-weight: bold;">Τηλέφωνο Παραλήπτη</label>
                </div>
                <div>
                    <input type="text" id="phone_number">
                    <input type="hidden" name="user_id" id="user_id">
                    <input type="hidden" name="user_id" id="type_of_user">
                </div>
            </div>

            <div class="form-row" style="margin-bottom: 1em; margin-top: 1em;">
                <?php echo sms_instructions_text(); ?>
                <?php echo instructions_sms_list('person'); ?>
            </div>

            <div class="form-row">
                <div>
                    <label for="message_user_field" style="font-weight: bold;">Μήνυμα</label>
                </div>
                <div>
                    <textarea name="message_user_field" id="message_user_field_" class="regular-text"
                        style="width: 375px !important; height: 200px !important;"><?php echo esc_textarea($custom_value); ?></textarea>
                </div>
            </div>

            <div style="margin-bottom:1em!important;display:flex;justfy-content:flex-end;width:100%!important;">

                <span id="character_count"></span>
                &nbsp;
                <span id="character_warning"></span>

            </div>
            <div class="footer_modal_">
                <button class="btn btn-dark " id="send-sms-button-user_">Αποστολή SMS</button><br />
                <?php echo close_modal_btn(); ?>
            </div>
            <span class="description"></span>

        </div>

        <script>
            jQuery(document).ready(function ($) {
                $('#template_options_').on('change', function () {
                    var selectedTemplateId = $(this).val();


                    if (selectedTemplateId !== '') {

                        $.ajax({
                            url: '<?php echo admin_url('admin-ajax.php'); ?>',
                            type: 'POST',
                            data: {
                                action: 'get_template_details',
                                templateId: selectedTemplateId
                            },
                            success: function (response) {

                                var trimmedResponse = response.trim();
                                $('#message_user_field_').val(trimmedResponse);
                                check_char_count("#singularModal #message_user_field_", "#singularModal");
                            }
                        });
                    } else {

                        $('#message_user_field_').val('');
                    }
                });
            });
        </script>

        <script>
            jQuery(document).ready(function ($) {
                $('#message_user_phone').val($('#billing_phone').val());

                $('#send-sms-button-user_').on('click', function (e) {
                    e.preventDefault();
                    var smsMessageuser = $('#message_user_field_').val();
                    var userIDs = [];

                    // $('input[name="select_user[]"]:checked').each(function () {

                    userIDs.push($('#user_id').val())
                    // });

                    if (smsMessageuser.trim() === '') {

                        alert('Please enter a message before sending.');
                    } else {

                        $.ajax({
                            url: '<?php echo admin_url('admin-ajax.php'); ?>',
                            method: 'POST',
                            data: {
                                action: 'send_sms_mass_callback',
                                user_ids: userIDs,
                                // phoneNumber: phoneNumberuser,
                                message: smsMessageuser
                            },
                            success: function (response) {

                                console.log(response);
                                alert('Message sent!');

                                window.location.reload();

                                $('#message_user_field_').val('');
                                $('#billing_phone').val('');
                            },
                            error: function (error) {

                                console.error(error);
                            }
                        });


                    }
                });
            });
        </script>
    </div>
        <?php
}

///// GUEST MODALS ////

function mass_sms_modal_function_guest()
{
    ?>
        <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <?php echo send_sms_heading(); ?>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <?php echo send_mass_sms_modal_content_guest(); ?>
                    </div>
                    <!-- <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>

                </div> -->
                </div>
            </div>
        </div>
        <?php
}

function send_mass_sms_modal_content_guest()
{

    $sms_options = get_presets();


    ?>
        <div class="modulus-user-sms">

            <div style="display: flex; flex-direction:column;">
                <label for="template_options" style="font-weight: bold; margin-right: 46px;">Πρότυπο Μηνύματος</label>
                
                <select id="template_options" name="template_options">
                    <option value="">
                        <?php _e('-Επιλέξτε-', 'woo-sms-alerts'); ?>
                    </option>
                    <?php
                    foreach ($sms_options as $value) {
                        echo '<option value="' . esc_attr($value['id']) . '">' . esc_html($value['title']) . '</option>';
                    }
                    ?>
                </select>
            </div>
            <div class="form-row" style="margin-bottom:1em;margin-top:1em;">
                <?php echo sms_instructions_text();
                echo instructions_sms_list('person');
                ?>


            </div>
            <div class="form-table">
                <div class="form-row">
                    <div>
                        <label for="message_user_field" style="font-weight: bold;">Μήνυμα</label>
                    </div>
                    <div>
                        <textarea name="message_user_field" id="message_user_field" class="regular-text"
                            style="width: 375px !important; height: 200px !important;"><?php echo esc_textarea($custom_value); ?></textarea>
                    </div>
                </div>
            </div>

            <div style="margin-bottom:1em!important;display:flex;justfy-content:flex-end;width:100%!important;">

                <span id="character_count"></span>
                &nbsp;
                <span id="character_warning"></span>

            </div>
            <div class="footer_modal_">
                <button class="button button-primary sms-button-user" id="send-sms-button-user">Αποστολή SMS</button><br />
                <?php echo close_modal_btn(); ?>
            </div>

            <span class="description"></span>

        </div>

        <script>
            jQuery(document).ready(function ($) {
                $('#template_options').on('change', function () {
                    var selectedTemplateId = $(this).val();


                    if (selectedTemplateId !== '') {

                        $.ajax({
                            url: '<?php echo admin_url('admin-ajax.php'); ?>',
                            type: 'POST',
                            data: {
                                action: 'get_template_details',
                                templateId: selectedTemplateId
                            },
                            success: function (response) {

                                var trimmedResponse = response.trim();
                                $('#message_user_field').val(trimmedResponse);
                                check_char_count("#exampleModal #message_user_field", "#exampleModal");
                            }
                        });
                    } else {

                        $('#message_user_field').val('');
                    }
                });
            });
        </script>

        <script>
            jQuery(document).ready(function ($) {
                $('#message_user_phone').val($('#billing_phone').val());

                $('#send-sms-button-user').on('click', function (e) {
                    e.preventDefault();
                    var smsMessageuser = $('#message_user_field').val();
                    var phoneNumberuser = [];

                    $('input[name="select_user[]"]:checked').each(function () {

                        phoneNumberuser.push($(this).val())
                    });
                    var order_ids = [];
                    $('input[name="select_user[]"]:checked').each(function () {

                        order_ids.push($(this).data("orderid"))
                    });
                    if (smsMessageuser.trim() === '') {

                        alert('Please enter a message before sending.');
                    } else {
                        $.ajax({
                            url: '<?php echo admin_url('admin-ajax.php'); ?>',
                            method: 'POST',
                            data: {
                                action: 'send_sms_mass_callback_guest',
                                order_id: order_ids,
                                phoneNumber: phoneNumberuser,
                                message: smsMessageuser
                            },
                            success: function (response) {

                                console.log(response);
                                alert('Message sent!');

                                window.location.reload();

                                $('#message_user_field').val('');
                                $('#billing_phone').val('');
                            },
                            error: function (error) {

                                console.error(error);
                            }
                        });
                    }
                });
            });
        </script>

        <?php
}

function mass_sms_modal_function_singular_guest()
{
    ?>
        <div class="modal fade" id="singularModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <?php echo send_sms_heading(); ?>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <?php echo send_mass_sms_modal_content_singular_guest(); ?>
                    </div>
                    <!-- <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal" id="close_modal">Close</button>

                </div> -->
                </div>
            </div>
        </div>
        <?php
}


function send_mass_sms_modal_content_singular_guest()
{

    $sms_options = get_presets();

    ?>
        <div class="modulus-user-sms">

            <div style="display: flex;flex-direction:column;">
                <label for="template_options" style="font-weight: bold; margin-right: 46px;">Πρότυπο Μηνύματος</label>
                <select id="template_options_" name="template_options">
                    <option value="">
                        <?php _e('-Επιλέξτε-', 'woo-sms-alerts'); ?>
                    </option>
                    <?php
                    foreach ($sms_options as $value) {
                        echo '<option value="' . esc_attr($value['id']) . '">' . esc_html($value['title']) . '</option>';
                    }
                    ?>
                </select>
            </div>

            <div class="form-container">
                <div class="form-row">
                    <label for="message_user_phone" style="font-weight: bold;">Τηλέφωνο Παραλήπτη</label>
                    <div>
                        <input type="text" id="phone_number">
                        <input type="hidden" name="user_id" id="user_id">
                    </div>
                </div>

                <div class="form-row" style="margin-bottom: 1em; margin-top: 1em;">
                    <?php echo sms_instructions_text(); ?>
                    <?php instructions_sms_list('person'); ?>
                </div>

                <div class="form-row">
                    <label for="message_user_field" style="font-weight: bold;">Μήνυμα</label>
                    <div>
                        <textarea name="message_user_field" id="message_user_field_" class="regular-text"
                            style="width: 375px !important; height: 200px !important;"><?php echo esc_textarea($custom_value); ?></textarea>
                    </div>
                </div>
            </div>

            <div style="margin-bottom:1em!important;display:flex;justfy-content:flex-end;width:100%!important;">

                <span id="character_count"></span>
                &nbsp;
                <span id="character_warning"></span>

            </div>
            <div class="footer_modal_">
                <button class="btn btn-dark " id="send-sms-button-user_">Αποστολή SMS</button>
                <?php echo close_modal_btn(); ?>
            </div>

            <span class="description"></span>

        </div>

        <script>
            jQuery(document).ready(function ($) {
                $('#template_options_').on('change', function () {
                    var selectedTemplateId = $(this).val();


                    if (selectedTemplateId !== '') {

                        $.ajax({
                            url: '<?php echo admin_url('admin-ajax.php'); ?>',
                            type: 'POST',
                            data: {
                                action: 'get_template_details',
                                templateId: selectedTemplateId
                            },
                            success: function (response) {

                                var trimmedResponse = response.trim();
                                $('#message_user_field_').val(trimmedResponse);
                                check_char_count("#singularModal #message_user_field_", "#singularModal");
                            }
                        });
                    } else {

                        $('#message_user_field_').val('');
                    }
                });
            });
        </script>

        <script>
            jQuery(document).ready(function ($) {
                $('#message_user_phone').val($('#billing_phone').val());

                $('#send-sms-button-user_').on('click', function (e) {
                    e.preventDefault();
                    var smsMessageuser = $('#message_user_field_').val();
                    var phoneNumber = [];
                    var order_ids = [];
                    // $('input[name="select_user[]"]:checked').each(function () {

                    phoneNumber.push($('#phone_number').val())
                    // });

                    order_ids.push($('#user_id').val())
                    if (smsMessageuser.trim() === '') {

                        alert('Please enter a message before sending.');
                    } else {



                        $.ajax({
                            url: '<?php echo admin_url('admin-ajax.php'); ?>',
                            method: 'POST',
                            data: {
                                action: 'send_sms_mass_callback_guest',
                                order_id: order_ids,
                                phoneNumber: phoneNumber,
                                message: smsMessageuser
                            },
                            success: function (response) {

                                // console.log(response);
                                alert('Message sent!');

                                window.location.reload();

                                $('#message_user_field_').val('');
                                $('#billing_phone').val('');
                            },
                            error: function (error) {

                                console.error(error);
                            }
                        });


                    }
                });
            });
        </script>

        <?php
}



function logs_modal()
{
    ?>
        <div class="modal fade" id="logs_modal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <div class="modal-title">
                            <h2><b>Ιστορικό SMS</b></h2>

                        </div>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"
                            id="close_modal">Ακύρωση</button>

                    </div>
                </div>
            </div>
        </div>
        <?php
}